diff -urN punbb-1.2.8/upload/include/common.php punbb-1.2.9/upload/include/common.php
--- punbb-1.2.8/upload/include/common.php	Thu Jul  7 19:38:16 2005
+++ punbb-1.2.9/upload/include/common.php	Sun Oct 16 12:02:42 2005
@@ -80,6 +80,11 @@
 // Load the functions script
 require PUN_ROOT.'include/functions.php';
 
+// Reverse the effect of register_globals
+if (@ini_get('register_globals'))
+	unregister_globals();
+
+
 // Load DB abstraction layer and connect
 require PUN_ROOT.'include/dblayer/common_db.php';
 
diff -urN punbb-1.2.8/upload/include/functions.php punbb-1.2.9/upload/include/functions.php
--- punbb-1.2.8/upload/include/functions.php	Thu Sep 22 00:35:32 2005
+++ punbb-1.2.9/upload/include/functions.php	Sun Oct 16 12:02:42 2005
@@ -1050,6 +1050,28 @@
 
 
 //
+// Unset any variables instantiated as a result of register_globals being enabled
+//
+function unregister_globals()
+{
+	// Prevent script.php?GLOBALS[foo]=bar
+	if (isset($_REQUEST['GLOBALS']) || isset($_FILES['GLOBALS']))
+		exit('I\'ll have a steak sandwich and... a steak sandwich.');
+	
+	// Variables that shouldn't be unset
+	$no_unset = array('GLOBALS', '_GET', '_POST', '_COOKIE', '_REQUEST', '_SERVER', '_ENV', '_FILES');
+
+	// Remove elements in $GLOBALS that are present in any of the superglobals
+	$input = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_ENV, $_FILES, isset($_SESSION) && is_array($_SESSION) ? $_SESSION : array());
+	foreach ($input as $k => $v)
+	{
+		if (!in_array($k, $no_unset) && isset($GLOBALS[$k]))
+			unset($GLOBALS[$k]);
+	}
+}
+
+
+//
 // Dump contents of variable(s)
 //
 function dump()
diff -urN punbb-1.2.8/upload/install.php punbb-1.2.9/upload/install.php
--- punbb-1.2.8/upload/install.php	Thu Sep 22 00:42:32 2005
+++ punbb-1.2.9/upload/install.php	Sun Oct 16 11:46:40 2005
@@ -24,7 +24,7 @@
 
 
 // The PunBB version this script installs
-$punbb_version = '1.2.8';
+$punbb_version = '1.2.9';
 
 
 define('PUN_ROOT', './');
diff -urN punbb-1.2.8/upload/search.php punbb-1.2.9/upload/search.php
--- punbb-1.2.8/upload/search.php	Thu Sep 22 00:36:42 2005
+++ punbb-1.2.9/upload/search.php	Sun Oct 16 11:48:28 2005
@@ -387,6 +387,7 @@
 
 
 		// Prune "old" search results
+		$old_searches = array();
 		$result = $db->query('SELECT ident FROM '.$db->prefix.'online') or error('Unable to fetch online list', __FILE__, __LINE__, $db->error());
 
 		if ($db->num_rows($result))
